const int NAME_COUNT=200;
const string names[NAME_COUNT] = {"angle","ant","apple","arch","arm","army","baby",
"bag","ball","band","basin","basket","bath","bed",
"bee","bell","berry","bird","blade","board","boat",
"bone","book","boot","bottle","box","boy","brain",
"brake","branch","brick","bridge","brush","bucket",
"bulb","button","cake","camera","card","carriage",
"cart","cat","chain","cheese","chest","chin","church",
"circle","clock","cloud","coat","collar","comb","cord",
"cow","cup","curtain","cushion","dog","door","drain",
"drawer","dress","drop","ear","egg","engine","eye",
"face","farm","feather","finger","fish","flag","floor",
"fly","foot","fork","fowl","frame","garden","girl",
"glove","goat","gun","hair","hammer","hand","hat",
"head","heart","hook","horn","horse","hospital","house",
"island","jewel","kettle","key","knee","knife","knot",
"leaf","leg","library","line","lip","lock","map","match",
"monkey","moon","mouth","muscle","nail","neck","needle",
"nerve","net","nose","nut","office","orange","oven","parcel",
"pen","pencil","picture","pig","pin","pipe","plane","plate",
"plough/plow","pocket","pot","potato","prison","pump","rail",
"rat","receipt","ring","rod","roof","root","sail","school",
"scissors","screw","seed","sheep","shelf","ship","shirt",
"shoe","skin","skirt","snake","sock","spade","sponge","spoon",
"spring","square","stamp","star","station","stem","stick",
"stocking","stomach","store","street","sun","table","tail",
"thread","throat","thumb","ticket","toe","tongue","tooth",
"town","train","tray","tree","trousers","umbrella","wall",
"watch","wheel","whip","whistle","window","wing","wire","worm"};

struct NameDat {
    int name;
    int num;
    bool operator==(const NameDat& other)
    {
        return name==other.name && num==other.num;
    }
};

string getName(const NameDat& nd)
{
    stringstream s;
    s<< names[nd.name];
    if (nd.num!=0)
        s<<nd.num;
    return s.str();
}

struct ProgressData {
	time_t starttime;
	NameDat namedat;
    bool confirmationseen;
	int task;
    int score;
	ProgressData();
};

int curteam;

int tempteamtype;//==0,1,2,3,4;

struct Challenge {
	string pretext;
    string posttext;
	int timetocomplete;
	int nextchallenge;
};

const int CHALLENGECOUNT=100;
const int STARTCHALLENGE=0;
const int ENDCHALLENGE=-1;
const int SINGLEPLAYERCHALLENGE=0;

const int start[5]={0,17,9,1,23};

bool playeraddition;

const Challenge challenges[CHALLENGECOUNT] =
{
    (Challenge) //SINGLE-PLAYER
    {
        "Find somebody else to play with.",
        "Can you both confirm that you are here?",
        0,
        -1
    },
    (Challenge) //Lovers
    {
        "Hold hands for at least one minute.",
        "Can you both confirm that you held hands for at least one minute?",
        60,
        2
    },
    (Challenge)
    {
        "Kiss each other for at least one minute.",
        "Can you confirm that you both kissed for the duration of at least one minute?",
        60,
        3
    },
    (Challenge)
    {
        "One of you should spank the bare arse of the other no less than ten times.",
        "Can you confirm that bare arse-spanking was reciprocally performed?",
        0,
        4
    },
    (Challenge)
    {
        "Please both of you loudly declare an intent to fuck each other.",
        "Did you both loudly declare a firm intent to fuck?",
        0,
        5
    },
    (Challenge)
    {
        "Fuck.",
        "Did you both fuck?",
        0,
        6
    },
    (Challenge)
    {
        "Buy some sex toys together.",
        "Did go out and buy some sex toys?",
        0,
        6
    },
    (Challenge)
    {
        "Fist.",
        "Did one of you fist the other?",
        0,
        7
    },
    (Challenge)
    {
        "Loudly declare unending love for one-another.",
        "Did you both loudly declare unending love?",
        0,
        ENDCHALLENGE
    },
    (Challenge)//Friends
    {
        "High-five each other.",
        "Did you high-five each other?",
        0,
        9
    },
    (Challenge)
    {
        "Insult each other.",
        "Did you insult each other?",
        0,
        10
    },
    (Challenge)
    {
        "Hug.",
        "Did you hug?",
        0,
        11
    },
    (Challenge)
    {
        "Get two other people to play this game.",
        "Did you get two other people to play this game?",
        0,
        23
    },
    (Challenge)
    {
        "Drink each a glass of water.",
        "Can you confirm that you both drank a glass of water?",
        0,
        12
    },
    (Challenge)
    {
        "Improvise a piece of music together right now for several minutes.",
        "Did you improvise together?",
        0,
        13
    },
    (Challenge)
    {
        "Buy an extra-large dildo together.",
        "Can you confirm that you bought an extra-large dildo?",
        0,
        12
    },
    (Challenge)
    {
        "Go play some other video games together.",
        "Did you both play some other video games together?",
        1800,
        ENDCHALLENGE
    },
    (Challenge)//family
    {
        "Pat each other on the back.",
        "Did you both pat each other on the back?",
        0,
        15
    },
    (Challenge)
    {
        "Together, call another family member and tell them what you're doing.",
        "Did you together call another family member and tell them what you are doing?",
        0,
        16
    },
    (Challenge)
    {
        "Go off for half an hour and have a tea/coffee together.",
        "Did you go have tea/coffee together?",
        1800,
        17
    },
    (Challenge)
    {
        "Paint a picture together.",
        "Did you paint a picture together?",
        0,
        18
    },
    (Challenge)
    {
        "Go see a movie together.",
        "Did you go see a movie together?",
        300,
        19
    },
    (Challenge)
    {
        "Commit incest.",
        "Did you both commit incest?",
        0,
        ENDCHALLENGE
    },
    (Challenge)//strangers
    {
        "Shake hands.",
        "Did you both shake hands?",
        0,
        21
    },
    (Challenge)
    {
        "Introduce yourselves.",
        "Did you introduce yourselves?",
        0,
        22
    },
    (Challenge)
    {
        "Get two other people to play this game.",
        "Did you get two other people to play this game?",
        0,
        23
    },
    (Challenge)
    {
        "Meet back here in one hour.",
        "Are both of you back?",
        3600,
        24
    },
    (Challenge)
    {
        "One of you should, unconditionally, gift the other 30 units of currency.",
        "Did one of you gift, unconditionally, the other 30 units of currency?",
        0,
        25
    },
    (Challenge)
    {
        "Kiss each other on the cheek.",
        "Did you both kiss each other on the cheek?",
        0,
        ENDCHALLENGE
    },
    (Challenge)
    {
        "",
        "",
        60,
        27
    },
    (Challenge)
    {
        "",
        "",
        60,
        28
    },
    (Challenge)
    {
        "",
        "",
        60,
        ENDCHALLENGE
    },
};

vector<ProgressData> progressdatas;

#include <fstream>


void save()
{
	ofstream file;
	file.open("savedat.bin", ios::trunc);
    for (int i=0;i<progressdatas.size();i++)
    {
        file<<progressdatas[i].starttime<<","<<progressdatas[i].namedat.name<<","<<progressdatas[i].namedat.num<<","<<progressdatas[i].task<<","<<endl;
    }
    file.close();
}

ProgressData parseline(string s)
{
    ProgressData pd;
    string curtoken;

    curtoken="";
    int state=0;
    for (int i=0;i<s.size();i++)
    {
        if (s[i]==',')
        {
            switch (state)
            {
                case 0:
                    pd.starttime=atoi(curtoken.c_str());
                    break;
                case 1:
                    pd.namedat.name=atoi(curtoken.c_str());
                    break;
                case 2:
                    pd.namedat.num=atoi(curtoken.c_str());
                    break;
                case 3:
                    pd.task=atoi(curtoken.c_str());
                    break;
            }
            curtoken="";
            state++;
        }
        else curtoken+=s[i];
    }
    return pd;
}

void load()
{

    ifstream file("savedat.bin");


    progressdatas.clear();
    if (file.is_open())
    {
        while (! file.eof() )
        {
            string s;
            getline (file,s);
            ProgressData pd = parseline(s);
            progressdatas.push_back(pd);
            cout<<"loading line "<<getName(pd.namedat)<<endl;
        }
        file.close();
    }

}

bool parsename(const string& s, NameDat& result)
{
    for (int i=0;i<NAME_COUNT;i++)
    {
        if (s.find(names[i].c_str())==0)
        {
            result.name=i;
            if (s.length()==names[i].length())
            {
                result.num=0;
                return true;
            }
            else
            {
                string numbercand(s.begin()+names[i].length(),s.end());

                int nNumberCand = atoi(numbercand.c_str());
                if (nNumberCand == 0)
                    continue;
                result.num=nNumberCand;
                return true;
            }
        }
    }
    return false;
}

bool nameExists(const NameDat& namedat)
{
    for (int i=0;i<progressdatas.size();i++)
    {
        if (progressdatas[i].namedat==namedat)
            return true;
    }
    return false;
}

//generate new name
ProgressData::ProgressData()
{
	int curlevel=0;
	int curword=0;
    score=1;
    confirmationseen=false;

	while(true)
	{
        //for each level
		for (int i=0;i<NAME_COUNT;i++)
		{
            bool foundfreeword=true;
            //for each word
			for (unsigned int j=0;j<progressdatas.size();j++)
			{
				if (progressdatas[j].namedat.num==curlevel && progressdatas[j].namedat.name==i)
				{
                    foundfreeword=false;
                    break;
				}
			}
            if (foundfreeword)
            {
                curword=i;
                goto out;
            }
		}
		curlevel++;
	}
out:
	namedat.name=curword;
	namedat.num=curlevel;

	task=-1;
	starttime=-1;
}
